;     AT90S2313
; : Fahivec.  2017.

.include "2313def.inc"	; Appnotes DEF-
.include "DEF_SDU.inc"	;  

.cseg
.org 0
; ***** INTERRUPT VECTORS ************************************************
RJMP RESET
RETI		;.equ	INT0addr	= 0x0001	; External Interrupt Request 0
RETI		;.equ	INT1addr	= 0x0002	; External Interrupt Request 1
RETI		;.equ	ICP1addr	= 0x0003	; Timer/Counter1 Capture Event
RJMP T1_CTC	;.equ	OC1addr	= 0x0004	; Timer/Counter1 Compare Match
RETI		;.equ	OVF1addr	= 0x0005	; Timer/Counter1 Overflow
RJMP T0_OVF	;.equ	OVF0addr	= 0x0006	; Timer/Counter0 Overflow
RETI		;.equ	URXCaddr	= 0x0007	; UART, Rx Complete
RETI		;.equ	UDREaddr	= 0x0008	; UART Data Register Empty
RETI		;.equ	UTXCaddr	= 0x0009	; UART, Tx Complete
;.equ	ACIaddr	= 0x000a	; Analog Comparator
; ************************************************************************
; Comparator Interupt Routine
	PUSHF
	inc	Count		;  

;	TOGGLE_IO	LED_PORT, LED_T	; TOGGLE_IO I/O, Bit
	POPF
RETI
;--------------------------------------------------------------
T0_OVF:					; Timer0 Interupt Routine
		PUSHF
		andi	Count, Mask		;    
		mov		Cnt_Tmp, Count	;    
		clr		Count
		sbr		Flag, 1<<Decode	;   
		outi	TCNT0,	100		;   0 .10 
		POPF					; ( XTAL/256)
RETI
;--------------------------------------------------------------
T1_CTC:					; Timer 1 CTC (Compare match A)
		PUSHF
		in		Temp, OCR1AL
		lsr		Temp				;      
		brcc	T1_1
		ldi		Temp, 0b10000000	;      (0)
T1_1:	out		OCR1AL, Temp
		mov		BAM_R, Temp			;    
		sbr		Flag, 1<<BAM_F		;    BAM
		POPF
RETI

; ************************************************************************
RESET:			;  
	cli
	STACK_INIT	; Macro SP=RAMEND

	outi	ACSR, 1<<ACD	; Analog Comparator OFF

	clr NULL			; Zerro-Register
	clr Count			; 
	clr Flag			; 

	outi	LED_DDR, 1<<LED_Y | 1<<LED_R | 1<<LED_G | 1<<LED_B	;    

;	outi	LED_DDR, 1<<LED_Y | 1<<LED_R | 1<<LED_G | 1<<LED_B	| 1<<LED_T;    

	outi	TCCR0,	1<<CS02 ; 0  = XTAL/256
	outi	TCNT0,	100		;   0 .10  ( XTAL/256)

	outi	TCCR1B,	1<<CTC1 | 1<<CS11 | 1<<CS10	;  1: CTC , XTAL/64
	out		OCR1AH,	NULL						;     =0
	outi	OCR1AL, 0b10000000					;    ""  (128)

	outi	TIMSK, 1<<TOIE0 | 1<<OCIE1A			;   

	outi	ACSR, 1<<ACIE | 1<<ACIS1 | 1<<ACIS0	;      
	sei
					;   
	clr	S_YELLOW	;  
	ser	S_RED		;  -  100%
	ser	S_GREEN
	ser	S_BLUE

MAIN:					;********    ********************
	sbrc	Flag, BAM_F			;   ,
	rcall	BAM_Proc			;       

	cpi		BAM_R, 0b00000100	;   BAM   
	brlo	MAIN				;    
	sbrc	Flag, Decode
	rcall	Decoder				;     

	rjmp	MAIN

; ***************************************************************************

Decoder:							;    count
	mov Temp1, Cnt_Tmp
	cpi	Temp1,0			;   0?
	brne	DEC1
	INCREASE	S_YELLOW
	DECREASE	S_RED
	DECREASE	S_GREEN
	DECREASE	S_BLUE
	rjmp	DEC0
DEC1:
	cpi	Temp1,1			;   1?
	brne	DEC2
	INCREASE	S_RED
	DECREASE	S_GREEN
	DECREASE	S_BLUE
	DECREASE	S_YELLOW
	rjmp	DEC0
DEC2:
	cpi	Temp1,2			;   2?
	brne	DEC3
	INCREASE	S_GREEN
	DECREASE	S_BLUE
	DECREASE	S_RED
	DECREASE	S_YELLOW
	rjmp	DEC0
DEC3:
	INCREASE	S_BLUE
	DECREASE	S_GREEN
	DECREASE	S_RED
	DECREASE	S_YELLOW
DEC0:

	BRIG	RED		,	S_RED		;    
	BRIG	GREEN	,	S_GREEN		;   
	BRIG	BLUE	,	S_BLUE
	BRIG	YELLOW	,	S_YELLOW
/*
mov	RED, S_RED
mov GREEN, S_GREEN
mov BLUE, S_BLUE
mov YELLOW, S_YELLOW
*/
	cbr		Flag,	1<<Decode	;  ,  
RET

;.include "Exp255.inc"	;    
.include "Quad.inc"	;    
;--------------------------------------------------------------
BAM_Proc:					;      BAM
	BAM_LED	RED,	LED_R		;     
	BAM_LED	GREEN,	LED_G
	BAM_LED	BLUE,	LED_B
	BAM_LED	YELLOW,	LED_Y
	cbr		Flag,	1<<BAM_F	;  ,  BAM 
RET
